#include <bits/stdc++.h>
using namespace std;
int main(int argc, char** argv) {
	int n;
	cin>>n;
	int mat[n-1][2];
	char niz[n-1];
	int broj[3];
	for(int i=0;i<n-1;i++)
	{
		cin>>mat[i][0];
		cin>>mat[i][1];
		cin>>niz[i];
		if(niz[i]=='S') broj[0]++;
		else if(niz[i]=='I') broj[1]++;
		else if(niz[i]=='O') broj[2]++;
	}
	sort(broj,broj+3);
	if(broj[1]==1 && broj[0]==1) cout<<broj[2];
	else if(broj[0]==0 || broj[1]==0 || broj[2]==0) cout<<0;
	else cout<<broj[0]*broj[1]*broj[2];
	return 0;
}